// D import file generated from 'gl3n/color/hsv.d'
module gl3n.color.hsv;
private 
{
    import std.conv : to;
    import gl3n.linalg : vec3, vec4;
    import gl3n.math : min, max, floor;
    version (unittest)
{
    import gl3n.math : almost_equal;
}
}
nothrow pure @safe vec3 rgb2hsv(vec3 inp)
{
vec3 ret = vec3(0F,0F,0F);
float h_max = max(inp.r,inp.g,inp.b);
float h_min = min(inp.r,inp.g,inp.b);
float delta = h_max - h_min;
if (delta == 0F)
{
ret.x = 0F;
}
else
if (inp.r == h_max)
{
ret.x = (inp.g - inp.b) / delta;
}
else
if (inp.g == h_max)
{
ret.x = 2 + (inp.b - inp.r) / delta;
}
else
{
ret.x = 4 + (inp.r - inp.g) / delta;
}
ret.x = ret.x * 60;
if (ret.x < 0)
{
ret.x = ret.x + 360;
}
if (h_max == 0F)
{
ret.y = 0F;
}
else
{
ret.y = delta / h_max;
}
ret.z = h_max;
return ret;
}

nothrow pure @safe vec4 rgb2hsv(vec4 inp)
{
return vec4(rgb2hsv(vec3(inp.rgb)),inp.a);
}

nothrow @safe vec3 hsv2rgb(vec3 inp)
{
if (inp.y == 0F)
{
return vec3(inp.zzz);
}
else
{
float var_h = inp.x * 6;
float var_i = to!(float)(floor(var_h));
float var_1 = inp.z * (1 - inp.y);
float var_2 = inp.z * (1 - inp.y * (var_h - var_i));
float var_3 = inp.z * (1 - inp.y * (1 - (var_h - var_i)));
if (var_i == 0F)
return vec3(inp.z,var_3,var_1);
else
if (var_i == 1F)
return vec3(var_2,inp.z,var_1);
else
if (var_i == 2F)
return vec3(var_1,inp.z,var_3);
else
if (var_i == 3F)
return vec3(var_1,var_2,inp.z);
else
if (var_i == 4F)
return vec3(var_3,var_1,inp.z);
else
return vec3(inp.z,var_1,var_2);
}
}

nothrow @safe vec4 hsv2rgb(vec4 inp)
{
return vec4(hsv2rgb(vec3(inp.xyz)),inp.w);
}

